

unsigned char user_buttons;
unsigned char theBit;


#define BIT_A        0x80
#define BIT_B        0x40
#define BIT_SELECT   0x20
#define BIT_START    0x10
#define BIT_UP       0x08
#define BIT_DOWN     0x04
#define BIT_LEFT     0x02
#define BIT_RIGHT    0x01

#define ASM_DELAY(x)       #asm("nop;") #asm("nop;")#asm("nop;") #asm("nop;")
#define ASM_HALF_DELAY(x)  #asm("nop;") #asm("nop;")

#define READ_BUTTON(x)    theBit = PIND.5; /* read a data bit.*/ \
               PORTD.1 = 1; /*clock high => shift bits in LSR */ \
               user_buttons = (user_buttons << 1) | theBit;      \
               ASM_HALF_DELAY();                                 \
               PORTD.1 = 0; /*clock low => ready to read.*/      \
               ASM_DELAY();
          
//stores the contents of the controller button state
//in the "user_buttons" variable.
//this takes 14 + 8*READ_BUTTON cycles, for a total of 86 cycles
inline void poll_controller(void)
{

  //start the controller poll process by latching the current values
  //of all of the buttons
  PORTD.2 = 1;

  ASM_HALF_DELAY(); //setup for clock..

  //send exactly one clock pulse to flop in the values
  PORTD.1 = 1;

  //hold clock high @ 2 MHz
  ASM_DELAY();

  PORTD.1 = 0; //clock goes low
  PORTD.2 = 0; //latch controller goes low
  ASM_DELAY();
  

  //read out the buttons in serial fashion.
  READ_BUTTON();
  READ_BUTTON();
  READ_BUTTON();
  READ_BUTTON();
  READ_BUTTON();
  READ_BUTTON();
  READ_BUTTON();
  READ_BUTTON();

  user_buttons = ~user_buttons;

}



