
//contains all the foreground sprites, 
//as well as sprite manipulation functions

#define NUM_SPRITES 1

#define SPRITE1X PORTA
#define SPRITE2X PORTB        
#define SPRITENUMS PORTC


#define SPRITE_PLAYER    0


flash unsigned char sprites[NUM_SPRITES][64] =
 {

 //sprite 0 -- solid black
 {0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0
 }
 
 };




inline void download_sprite(unsigned char spritenum)
{
  unsigned char pixel;
                   
  PORTD.6 = 0;
  PORTD.7 = 1;
  DATA_B = spritenum;
  
  for(pixel = 0; pixel < 64; pixel++)
  {
    ADDRESS = pixel;
    DATA_A = sprites[spritenum][pixel];

    //pump data clock
    DATA_CLOCK = 1;
    #asm("nop");
    DATA_CLOCK = 0;
  }

  //no longer downloading sprite.
  PORTD.6 = 0;
  PORTD.7 = 0;
  
}

//downloads all the sprites to the VGA board
void install_sprites(void)
{
  unsigned char i;
  for(i = 0; i < NUM_SPRITES; i++)
    download_sprite(i);
}


inline void disable_sprites(void)
{
  SPRITE1X = 0xFF; //don't draw sprite 1
  SPRITE2X = 0xFF; //don't draw sprite 2
}


inline void clear_sprite1(void)
{
  SPRITE1X = 0xFF; //don't draw sprite 1
}

inline void clear_sprite2(void)
{
  SPRITE2X = 0xFF; //don't draw sprite 2
}
           
inline void set_sprite1(unsigned char xoff, unsigned char id)
{
  unsigned char t;
  t = SPRITENUMS;
  t = t & 0xFC; //clear existing sprite 1
  SPRITENUMS = t | id;
  SPRITE1X = xoff;
}

inline void set_sprite2(unsigned char xoff, unsigned char id)
{
  unsigned char t;
  t = SPRITENUMS;
  t = t & 0xF3; //clear existing sprite 2
  SPRITENUMS = t | (id << 2); //TODO: Should sprite 2 ids be pre-shifted?
  SPRITE2X = xoff;
}








